#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five9004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five9004xi = {
                1: '-10x3y899z',
                2: '-110x289y844z',
                3: '-126x560y692z',
                4: '-128x291y841z',
                5: '-129x608y650z',
                6: '-142x827y324z',
                7: '-147x291y838z',
                8: '-157x559y686z',
                9: '-162x607y643z',
                10: '-166x290y835z',
                11: '-186x288y831z',
                12: '-186x821y316z',
                13: '-188x557y681z',
                14: '-196x604y637z',
                15: '-19x5y899z',
                16: '-205x285y828z',
                17: '-220x552y675z',
                18: '-225x280y824z',
                19: '-229x598y631z',
                20: '-229x813y308z',
                21: '-245x274y821z',
                22: '-251x546y669z',
                23: '-263x591y624z',
                24: '-265x266y817z',
                25: '-273x803y299z',
                26: '-27x265y859z',
                27: '-282x538y663z',
                28: '-284x258y813z',
                29: '-28x6y899z',
                30: '-296x582y618z',
                31: '-2x0y899z',
                32: '-304x248y809z',
                33: '-314x528y656z',
                34: '-315x790y291z',
                35: '-323x236y805z',
                36: '-330x571y611z',
                37: '-342x223y801z',
                38: '-345x517y650z',
                39: '-358x775y282z',
                40: '-360x209y797z',
                41: '-362x558y604z',
                42: '-375x503y644z',
                43: '-377x194y793z',
                44: '-37x6y899z',
                45: '-394x177y789z',
                46: '-395x543y598z',
                47: '-399x758y273z',
                48: '-405x488y638z',
                49: '-410x159y784z',
                50: '-425x139y780z',
                51: '-426x527y591z',
                52: '-42x272y856z',
                53: '-434x470y631z',
                54: '-440x119y775z',
                55: '-440x738y265z',
                56: '-453x97y771z',
                57: '-457x508y584z',
                58: '-463x451y625z',
                59: '-465x75y766z',
                60: '-46x5y898z',
                61: '-476x51y761z',
                62: '-479x717y256z',
                63: '-486x27y756z',
                64: '-487x487y577z',
                65: '-490x431y618z',
                66: '-494x1y752z',
                67: '-517x408y612z',
                68: '-517x465y570z',
                69: '-517x692y248z',
                70: '-543x384y605z',
                71: '-545x441y563z',
                72: '-555x666y239z',
                73: '-567x358y599z',
                74: '-56x3y898z',
                75: '-571x415y556z',
                76: '-58x278y853z',
                77: '-590x638y230z',
                78: '-591x331y592z',
                79: '-597x388y549z',
                80: '-612x302y585z',
                81: '-621x358y542z',
                82: '-625x608y222z',
                83: '-633x272y578z',
                84: '-63x605y662z',
                85: '-644x328y535z',
                86: '-651x241y571z',
                87: '-657x576y213z',
                88: '-65x0y897z',
                89: '-665x296y528z',
                90: '-669x208y564z',
                91: '-684x174y557z',
                92: '-685x263y520z',
                93: '-688x542y204z',
                94: '-698x139y550z',
                95: '-702x228y513z',
                96: '-709x103y543z',
                97: '-717x506y195z',
                98: '-718x192y506z',
                99: '-719x66y536z',
                100: '-732x155y498z',
                101: '-744x117y491z',
                102: '-744x469y187z',
                103: '-74x283y851z',
                104: '-754x79y483z',
                105: '-762x39y475z',
                106: '-768x0y468z',
                107: '-769x430y178z',
                108: '-792x390y169z',
                109: '-808x32y587z',
                110: '-813x349y160z',
                111: '-832x306y151z',
                112: '-848x263y142z',
                113: '-862x218y133z',
                114: '-874x173y124z',
                115: '-883x127y116z',
                116: '-889x81y107z',
                117: '-893x34y98z',
                118: '-92x286y848z',
                119: '-95x559y698z',
                120: '-96x608y656z',
                121: '-98x830y333z'}      
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire900five4xi" usage = "target function for charge9004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire900five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE900FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE900FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five9004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five9004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE900FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900five4xi.py                             
# -------------------------------------------------------------------------------------------------                